#include <pic.h>
#include "LCD_Defs.h"

/*---------------------------------------------------------------------------
	mߪDnئa
	(1)	m Timer 2 WPϥ
	(2)	mߤ_Aȵ{ ISR  wƻPާ@覡
	(3)  LCD Controller Wd (LCD O Layout аѦҽu
	(4)	Ƿ|pNt׻ݨDCOɶu@H_]X , D{ѦҺX
	    þާ@覡Bz  

	** Ъ`N APP-EDF09 N RC6 & RC7 H JP7 & JP6 P PIC18F46J50  RB4 & RB5 ۳s
	   nҼ{ LED6 & LED7 iQvT

	ϥ Compiler : HI-TECH PICC V9.70 in "LITE Mode"
  -------------------------------------------------------------------------*/ 
	
// -------------------------------------------------------------------------
// {ŧi Configuration Bits k 
// ԲӪĶؽаѦҦU MCU  header file 
// -------------------------------------------------------------------------
	__CONFIG(FOSC_INTOSC&WDTE_OFF&PWRTE_OFF&CP_OFF&BOREN_OFF); 
	__CONFIG(VCAPEN_RA0&PLLEN_OFF&LVP_OFF);

#define	LED8	LATB3

void 	Initialize_CPU(void) ; 
void	Initialize_TMR2(void) ;
void	Display_Time(void);
void	interrupt	ISRs(void);

volatile int			TMR2_Counter = 0 ;
volatile int			TMR2_Counter4Sec = 0 ;
volatile bit			UPDATE_TIME ;

volatile unsigned char	Sec = 0 , Min = 0 ;			
 
void main(void)
{	
 		Initialize_CPU();				// N CPU Initialize  16Mhz / Internal RC
		Initialize_TMR2() ;				// N Timer2 W 1ms _@ Timer !
		Initialize_LCD() ;				// W LCD ϥ
		PEIE = 1 ;						// PP䤤_
		GIE = 1;						// P Global _} !!

		UPDATE_TIME = 0 ;

		Blank_ALL_Digits() ;			// MҦLCDWr

			while(1)
			{ 
				if (UPDATE_TIME) 		// ISRs()|b 1 ɷ|]wX
				{
					Display_Time() ;	// ܮɶ MM.SS b LCD W 
					UPDATE_TIME = 0 ;
				}
			}
}

void	Display_Time(void)
{
		// --------------------------------------
		// ܮɶ MM.SS b LCD W
		// Ĥ@Ӧr !!
		// --------------------------------------
		DisplayDigit2(Min/10) ;
		DisplayDigit3(Min%10) ;
		DisplayDigit4(Sec/10) ;
		DisplayDigit5(Sec%10) ;

}	
	
void	interrupt	ISRs(void)
{
	if(TMR2IF)
	 {
		TMR2IF = 0 ;
		TMR2_Counter ++ ;
		TMR2_Counter4Sec ++ ;
		if ( TMR2_Counter >= 500 )		// ϥ TMR2_Counter Ӳֿn Timer 2 _
			{							// YO 500 F , Y 500 ms w
				LED8 = ~LED8 ;			//  LED8 ϦV@ , p@ LED8 1 |{@
				SEG_3DP = ~ SEG_3DP ;
				TMR2_Counter = 0 ;
			}
		if ( TMR2_Counter4Sec >= 1000 )
			{
				TMR2_Counter4Sec = 0 ;
				UPDATE_TIME = 1 ;
				Sec ++ ;
				if ( Sec >= 60)
				{
					Sec = 0 ;
					Min ++ ;
					if ( Min > 60 )
						 Min = 0 ;
				}
			}
	 }
 
}

void	Initialize_TMR2(void)
{
		PR2 = 249 ;				
		T2CON = 0b00000110 ;	//	Clock Prescale = 1:16 = 4us @ 16Mhz Fosc
								//	250 * 4us = 1ms
		TMR2IE = 1 ;			//  P Timer2 _ !!
}

void Initialize_CPU(void)
{
// Configure I/O pins for project	

							// Set internal oscillator frequency
	OSCCON = 0x78 ;			// 16 Mhz
							// Set up A-to-D Module
	ANSELA = 0x00 ;			//  
	ANSELB = 0x00 ;
	ANSELE = 0x00 ;
	ANSELD = 0x00 ;

	TRISB4 = 0 ;			// LCD COMs
	TRISB5 = 0 ;
	TRISA2 = 0 ;
	TRISD0 = 0 ;

	TRISB3 = 0;				// LED8
	RB3 = 1;
	TRISC6 = 0 ;			// TXD
	TRISC7 = 1 ;			// RXD 
	RC6 = 1 ;
 
 							// Turn off all interrupts
	INTCON = 0 ;			// Make sure interrupts are turn off
							// Configure Capture Compare PWM Module 2
 
}

