#include <pic.h>
#include <string.h>
#include "LCD_Defs.h"

/*---------------------------------------------------------------------------
	mߪDnئa
	(1)	m Timer 2 WPϥ
	(2)	mߤ_Aȵ{ ISR  wƻPާ@覡
	(3)  LCD Controller Wd (LCD O Layout аѦҽu
	(4)	ϥ UART ۩w榡r , :AXXXX ñN XXXX ҥN ADC ഫ
		ܩ LCD Panel

	** Ъ`N APP-EDF09 N RC6 & RC7 H JP7 & JP6 P PIC18F46J50  RB4 & RB5 ۳s
	   nҼ{ LED6 & LED7 iQvT

	ϥ Compiler : HI-TECH PICC V9.70 in "LITE Mode"
  -------------------------------------------------------------------------*/ 
	
// -------------------------------------------------------------------------
// {ŧi Configuration Bits k 
// ԲӪĶؽаѦҦU MCU  header file 
// ------------------------------------------------------------------------- 
	__CONFIG(FOSC_INTOSC&WDTE_OFF&PWRTE_OFF&CP_OFF&BOREN_OFF); 
	__CONFIG(VCAPEN_RA0&PLLEN_OFF&LVP_OFF);

#define	LED8	LATB3

void 	Initialize_CPU(void) ;
void	Show_ADC(void);
void	Initialize_TMR2(void) ;
void	Initialize_UART(void) ;

void	interrupt	ISRs(void);

volatile int			TMR2_Counter = 0 ;
volatile int			REC_Index = 0 ;
volatile unsigned char	REC_Temp ;
unsigned char			REC_Buffer[20];

volatile bit 			REC_A_LINE ;
int						Length ;
void main(void)
{
		REC_A_LINE = 0 ;
		
		Initialize_CPU() ;			// N CPU Initialize  16Mhz / Internal RC
		Initialize_LCD() ;			// W LCD ϥ	
		Initialize_TMR2() ;			// N Timer2 W 1ms _@ Timer !
		Initialize_UART() ;			// W UART  19200,N,8,1 @ 16Mhz Fosc ާ@Ҧ
		PEIE = 1 ;					// PP䤤_
		GIE = 1;					// P Global _} !!		
 
		Clear_LCD( );

		REC_Buffer[0] = ':';		//  Initial  Buffer ,  LCD  0
		REC_Buffer[1] = 'A';		// p@ , NSƤ]SY !
		REC_Buffer[2] = '0';
		REC_Buffer[3] = 0x00 ;
		Show_ADC() ;

	while(1)
	{ 
  		if (OERR || FERR)
			{
				CREN = 0 ;			// pGo Over Run  Frame Error 
				NOP();				// M CREN  error AѰ !
				NOP();
				CREN = 1 ;
			}

			if (REC_A_LINE)
			{
				REC_A_LINE = 0 ;	// _Aȵ{|b짹㪺 :AXXXX r
									// ]wX REC_A_LINE  1
				
				// ********************************************
				// 榡 :AXXXX , XXXX  ADC G !!
				// ҥHpGĤGӦr 'A' , ܽT ADC G
				// ********************************************
				if (REC_Buffer[1] == 'A')
					Show_ADC() ;
			}
	}
}	

void	Show_ADC(void)
{
	Length = strlen(REC_Buffer) ;
	Length -= 2 ;									// rꤤ :A

	SEG_BAT = ! SEG_BAT ;

	switch(Length)
	{
		case 1:
				BlankDigit2();						// NܪrM
				BlankDigit3();
				BlankDigit4();
				DisplayDigit5(REC_Buffer[2]-'0') ;	
				break ;	
		case 2:
				BlankDigit2();
				BlankDigit3();
				DisplayDigit4(REC_Buffer[2]-'0') ;
				DisplayDigit5(REC_Buffer[3]-'0') ;	
				break ;	
		case 3:
				BlankDigit2();
				DisplayDigit3(REC_Buffer[2]-'0') ;
				DisplayDigit4(REC_Buffer[3]-'0') ;	
				DisplayDigit5(REC_Buffer[4]-'0') ;
				break ;	
		case 4:
				DisplayDigit2(REC_Buffer[2]-'0') ;
				DisplayDigit3(REC_Buffer[3]-'0') ;	
				DisplayDigit4(REC_Buffer[4]-'0') ;
				DisplayDigit5(REC_Buffer[5]-'0') ;
				break ;	
		default:
				break ;
	}
}

// --------------------------------------------------------------------------
// _Aȵ{ⶵDnu@ :
// (1)  500ms ɶFɱN LED8 ϦV@ 
// (2)  UART r̮榡ӧP_O_ , æb̫ 0x00 
//     `N .. rꪺ榡 ":AXXXX" + 0x0a , 0x0d
// --------------------------------------------------------------------------	
void	interrupt	ISRs(void)
{
	if(TMR2IF)
	 {
		TMR2IF = 0 ;
		TMR2_Counter ++ ;
		if ( TMR2_Counter >= 500 )
			{
				LED8 = ~LED8 ;
				TMR2_Counter = 0 ;
			}
	 }
	else if (RCIF)
		{
			REC_Temp = RCREG ;		//	Read RCREG and save it to REC_Temp
			if (REC_Temp == 0x0d)	//	0x0d = end of a line 
			{	
				REC_Buffer[REC_Index] = 0x00 ;
				REC_Index = 0 ;

				// --------------------------------------------------------
				// M 0x0d , YĤ@ӦrD ':' 
				// ܦriण
				// ҥH⦳ı ...................
				// --------------------------------------------------------
				if (REC_Buffer[0] == ':' )
					REC_A_LINE = 1 ;
		 
			}
			else if ( REC_Temp > 0x20 && REC_Temp < 0x80 )	// ȱiѦr
				REC_Buffer[REC_Index++] = REC_Temp ;			
		}
}


void	Initialize_UART(void)
{
		TXSTA = 0b00100100 ;
		RCSTA = 0b10010000 ;
		SPBRG = 51 ;				// Ѧ Data Sheet k ,  FOSC = 16Mhz
		BRG16 = 0 ;					// SPBRG = 51 |o 19200  Baud Rate 
		RCIE = 1 ;					//  : BRGH = 1 
		TXIE = 0 ;					// SPBRG = (Fosc/Baud_Rate/16)-1
}

void	Initialize_TMR2(void)
{
		PR2 = 249 ;				
		T2CON = 0b00000110 ;	//	Clock Prescale = 1:16 = 4us @ 16Mhz Fosc
								//	250 * 4us = 1ms
		TMR2IE = 1 ;
}

void Initialize_CPU(void)
{
// Configure I/O pins for project	

							// Set internal oscillator frequency
	OSCCON = 0x78 ;			// 16 Mhz
							// Set up A-to-D Module
	ANSELA = 0x00 ;			//  
	ANSELB = 0x00 ;
	ANSELE = 0x00 ;
	ANSELD = 0x00 ;

	TRISB4 = 0 ;			// LCD COMs
	TRISB5 = 0 ;
	TRISA2 = 0 ;
	TRISD0 = 0 ;

	TRISB3 = 0;				// LED8
	RB3 = 1;
	TRISC6 = 0 ;			// TXD
	TRISC7 = 1 ;			// RXD 
	RC6 = 1 ;
 
 							// Turn off all interrupts
	INTCON = 0 ;			// Make sure interrupts are turn off
							// Configure Capture Compare PWM Module 2
 
}

