//
//******** ƪŧi  ***********
//

void Show_LCD_Test( void);
void Initialize_CPU(void) ;
void Show_UART_Receive(void); 
void Show_ADC(void);
void Show_CSM_Frequency (void);
void Show_MCP9800_Temperature (void);
void Show_LCD_Test( void); 
void Delay_Second(int);
void Delay_Long(void);
void Initialize_UART(void);

/*  MCP9800 & IIC    */
void Initialize_I2C_Master(void);
void Read_Temperature(void);
void Write_MCP9800_Config(void);
void IdleI2C( void );
void StartI2C( void );
unsigned char WriteI2C( unsigned char );
unsigned char ReadI2C( void );
void AckI2C( void );
void NotAckI2C( void );
void RestartI2C( void );
void StopI2C( void );
void I2C_Done(void);

/*  CSM & _ŧi */
void Cap_Init(void);
void Init_Timer4(void);
void interrupt isr(void) ;

/*  LCD Glass ŧi */
void Initialize_LCD(void) ;
void Clear_LCD (void);
void BlankDigit1(void);
void BlankDigit2(void);
void BlankDigit3(void);
void BlankDigit4(void);
void BlankDigit5(void);
void DisplayDigit1(unsigned char) ;
void DisplayDigit2(unsigned char) ;
void DisplayDigit3(unsigned char) ;
void DisplayDigit4(unsigned char) ;
void DisplayDigit5(unsigned char) ;


#define 	SCL 	RC3			// 	I2C }
#define		SDA		RC4
#define		SCL_DIR	TRISC3
#define		SDA_DIR	TRISC4

#define		MCP9800_Addr_Read	0b10011011  // MCP9800 URO
#define		MCP9800_Addr_Write	0b10011010	// ݰѦ Data Sheet
#define		MCP9800_Point_Temp	0b00000000
#define		MCP9800_Point_Conf  0b00000001
#define		MCP9800_Point_Hyst	0b00000010
#define		MCP9800_Point_Limit	0b00000011

#define		SW5			RD1
#define		SW6			RD2
// #define		LED6_On		LATC6=0		// OlWT LED Gη\
// #define		LED6_Off 	LATC6=1
// #define		LED7_On		LATC7=0
// #define		LED7_Off 	LATC7=1 
#define		LED8_On		LATB3=1
#define		LED8_Off 	LATB3=0
// #define 	LED6		LATC6  also is a TxD of UART
// #define 	LED7		LATC7  also is a RxD of UART
#define		LED8		LATB3

//
// N Hi-Tech PICC ҩwq pic16f1937.h ɸ̪ҨϥΨ쪺 SEGxCOMx ù LCD ܸ`\
// p@ӴNΥhOO@ SEGxCOMx hLCDW@`ܤF
// 
#define	SEG_1A		SEG20COM3  	// SEG2COM3  LCD Digital-1  A Segment
#define	SEG_1B		SEG20COM2	// SEG2COM2  LCD Digital-1  B Segmen
#define	SEG_1C		SEG20COM1
#define	SEG_1D		SEG0COM0
#define	SEG_1E		SEG0COM1
#define	SEG_1F		SEG0COM3
#define	SEG_1G		SEG0COM2
#define SEG_1DP		SEG20COM0

#define	SEG_2A		SEG18COM3
#define	SEG_2B		SEG18COM2
#define	SEG_2C		SEG18COM1
#define	SEG_2D		SEG19COM0
#define	SEG_2E		SEG19COM1
#define	SEG_2F		SEG19COM3
#define	SEG_2G		SEG19COM2
#define SEG_2DP		SEG18COM0

#define	SEG_3A		SEG3COM3
#define	SEG_3B		SEG3COM2
#define	SEG_3C		SEG3COM1
#define	SEG_3D		SEG16COM0
#define	SEG_3E		SEG16COM1
#define	SEG_3F		SEG16COM3
#define	SEG_3G		SEG16COM2
#define SEG_3DP		SEG3COM0

#define	SEG_4A		SEG22COM3
#define	SEG_4B		SEG22COM2
#define	SEG_4C		SEG22COM1
#define	SEG_4D		SEG23COM0
#define	SEG_4E		SEG23COM1
#define	SEG_4F		SEG23COM3
#define	SEG_4G		SEG23COM2
#define SEG_4DP		SEG22COM0

#define	SEG_5A		SEG15COM3
#define	SEG_5B		SEG15COM2
#define	SEG_5C		SEG15COM1
#define	SEG_5D		SEG4COM0
#define	SEG_5E		SEG4COM1
#define	SEG_5F		SEG4COM3
#define	SEG_5G		SEG4COM2

// Uwq LCD WSܲŸ
//
#define	SEG_oF		SEG21COM1	// SEG21COM1  LCD W oF (ئū)
#define	SEG_oC		SEG21COM2
#define	SEG_C		SEG5COM0
#define	SEG_A		SEG5COM1
#define	SEG_Slow	SEG5COM2
#define	SEG_Fast	SEG5COM3
#define	SEG_Max		SEG17COM0
#define	SEG_REC		SEG17COM1
#define	SEG_HOLD	SEG17COM2
#define	SEG_BAT		SEG17COM3
#define	SEG_m		SEG7COM0
#define	SEG_V		SEG7COM1
#define	SEG_S1		SEG7COM3
#define	SEG_S2		SEG7COM2
 
