#include <pic.h>

/*-----------------------------------------------------------
	mߪDnئa
	(1)	m Timer 2 WPϥ
	(2)	mߤ_Aȵ{ ISR  wƻPާ@覡

	** Ъ`N APP-EDF09 N RC6 & RC7 H JP7 & JP6 P PIC18F46J50  RB4 & RB5 ۳s
	   nҼ{ LED6 & LED7 iQvT

	ϥ Compiler : HI-TECH PICC V9.70 in "LITE Mode"
  ----------------------------------------------------------*/ 
	__CONFIG(FOSC_INTOSC&WDTE_OFF&PWRTE_OFF&CP_OFF&BOREN_OFF); 
	__CONFIG(VCAPEN_RA0&PLLEN_OFF&LVP_OFF);

#define	LED8	LATB3

void 	Initialize_CPU(void) ; 
void	Initialize_TMR2(void) ;
void	interrupt	ISRs(void);

volatile int			TMR2_Counter = 0 ;
 
void main(void)
{
		
 		Initialize_CPU();				// N CPU Initialize  16Mhz / Internal RC
		Initialize_TMR2() ;				// N Timer2 W 1ms _@ Timer !
		PEIE = 1 ;						// PP䤤_
		GIE = 1;						// P Global _} !!

			while(1)
			{ 
  				NOP() ;
			}
}	
	
void	interrupt	ISRs(void)
{
	if(TMR2IF)
	 {
		TMR2IF = 0 ;
		TMR2_Counter ++ ;
		if ( TMR2_Counter >= 500 )		// ϥ TMR2_Counter Ӳֿn Timer 2 _
			{							// YO 500 F , Y 500 ms w
				LED8 = ~LED8 ;			//  LED8 ϦV@ , p@ LED8 1 |{@
				TMR2_Counter = 0 ;
			}
	 }
 
}

void	Initialize_TMR2(void)
{
		PR2 = 249 ;				
		T2CON = 0b00000110 ;	//	Clock Prescale = 1:16 = 4us @ 16Mhz Fosc
								//	250 * 4us = 1ms
		TMR2IE = 1 ;			//  P Timer2 _ !!
}

void Initialize_CPU(void)
{
// Configure I/O pins for project	

							// Set internal oscillator frequency
	OSCCON = 0x78 ;			// 16 Mhz
							// Set up A-to-D Module
	ANSELA = 0x00 ;			//  
	ANSELB = 0x00 ;
	ANSELE = 0x00 ;
	ANSELD = 0x00 ;

	TRISB4 = 0 ;			// LCD COMs
	TRISB5 = 0 ;
	TRISA2 = 0 ;
	TRISD0 = 0 ;

	TRISB3 = 0;				// LED8
	RB3 = 1;
	TRISC6 = 0 ;			// TXD
	TRISC7 = 1 ;			// RXD 
	RC6 = 1 ;
 
 							// Turn off all interrupts
	INTCON = 0 ;			// Make sure interrupts are turn off
							// Configure Capture Compare PWM Module 2
 
}

